program define dnorm
        version 4.0

        preserve
        clear

        quietly {
                set obs 501
                gen x = 3*((_n-251)/250)
                gen y = .
                gen z = .}

        global mu=0
        global sig2=1
        global osig=1

        window control button "Reset"  15  5 25 12 HJN_B0
        window control button "mu +"   15 20 25 12 HJN_B1
        window control button "mu -"   15 35 25 12 HJN_B2
        window control button "var +"  15 50 25 12 HJN_B3
        window control button "var -"  15 65 25 12 HJN_B4
        window control button "Help"   15 80 25 12 HJN_B5
        window control button "Close"  15 95 25 12 HJN_B6

        global D_sm1 "Mean"
        global D_sm2 "Variance"
        window control static D_sm1    15 110 30 12
        window control static mu       50 110 25 12
        window control static D_sm2    15 125 30 12
        window control static sig2     50 125 25 12

        global HJN_B0 "trydr 0"
        global HJN_B1 "trydr 1"
        global HJN_B2 "trydr -1"
        global HJN_B3 "trydr 2"
        global HJN_B4 "trydr -2"
        global HJN_B5 "whelp dnorm"
        global HJN_B6 "exit 3000"

        gph open

        trydr 0

        noi window dialog "Normal Curves"  5 5 75 150

        gph close

        restore

end

program define trydr
        version 4.0

        local arg=`1'

        if `arg'!=0 {
        graph y z, xlabel ylabel xscale(-11,11) yscale(0,.6) c(l) s(i) l1(" ") l2(" ") b1(" ") b2(" ")  bbox(3000,0,23000,32000,850,400,0)  pen(3)
        }
                
        if `arg'==0 { 
                global mu=0
                global osig=1
                gph close 
                gph open}

        if `arg'==1 {
                global mu = min(5,$mu+1)}

        if `arg'==-1 {
                global mu = max(-5,$mu-1)}

        if `arg'==2 {
                global osig = max(.5,$osig-.1)}

        if `arg'==-2 {
                global osig = min(1.5,$osig+.1)}

        local sig = 1/$osig

        replace z = $mu + `sig'*x
        replace y = exp(-.5*((z-$mu)/`sig')^2)/(sqrt(2*3.1415926)*`sig')

        graph y z, xlabel ylabel xscale(-11,11) yscale(0,.6) c(l) s(i) l1(" ") l2(" ") b1(" ") b2(" ")  bbox(3000,0,23000,32000,850,400,0)  pen(2)

        gph pen 2
        local msig: display %4.2f `sig'*`sig'
        global sig2=`msig'
        
end
exit
