program define scatt1
        version 4.0        
        
        preserve
        global HJN_OV1
        global HJN_OV2

    global D_sm11 "   This lab shows what scatterplots look like for various values of the population correlation coefficient, rho. Each time you click on Run you will get new samples and the scatterplots will look slightly different. You can specify the sample size, n and what symbol you want plotted in the scatterplots (to print the scatterplots, symbol # 1 is the best)."
    window control static D_sm11 5 5 270 40
    
    global D_sm12 "Things to Notice: 1) Positive (negative) values of rho mean the points fall close to a line having positive (negative) slope, 2) The closer rho is to +1 or -1, the closer the points are to the line. 3) For values of rho between about -.4 to +.4, the scatterplots look very similar unless n is quite large."
    window control static D_sm12 5 50 270 40


        * To assign a default value include the following line
        global HJN_V1 = 500
        global HJN_1 "n"
        window control static HJN_1    5 92 10  8
        window control edit    20 92  20  8 HJN_V1

        global HJN_V2 = 0
        global HJN_2 "Symbol #"
        window control static HJN_2   50  92  35  8
        window control edit    95  92  10  8 HJN_V2

        
        window control button "Run"    125 90 25 12 HJN_B2
        window control button "Close"  155 90 25 12 HJN_B3
        window control button "Help"   185 90 25 12 HJN_B4
        
        global HJN_B2 "scatt1dr"
        global HJN_B4 "whelp scatt1"
        global HJN_B3 "exit 3000"

    scatt1dr
        
        noi window dialog "Scatterplots, I"  5 150 280 120
        restore
end

program define scatt1dr

        preserve
        clear

        tempvar e1 e2

        scalar n=$HJN_V1

        if n< 2 | n > 600 {
                sstopbox stop "sample size must be between 2 and 600"
                        exit}

        local sym=$HJN_V2

        if `sym'< 0 | `sym' > 6 {
                sstopbox stop "symbol number must be between 0 and 6"
                        exit}

        local nn=n
        quietly set obs `nn'

        scalar i = 1
        scalar j = 1
        scalar nc = 4000
        scalar nr = 6000
        scalar np = 4000
        scalar nix = 5000
        scalar niy = 5000
        scalar ii=1

        scalar rho = -1.0
        local mrho=rho

        gph open
        gph pen 1

        gen `e1' = uniform()
        gen `e2' = uniform()

        while i < 5 {

                scalar j = 1
                scalar nc = 4000

                while j < 6 {

                        if ii != 11 { scalar rho = rho + 0.1 }

                        local y1=nr-np
                        local y2=nr
                        local x1=nc
                        local x2=nc+np

                        gph line `y1' `x1' `y1' `x2' 1
                        gph line `y1' `x2' `y2' `x2' 1
                        gph line `y2' `x2' `y2' `x1' 1
                        gph line `y2' `x1' `y1' `x1' 1
                        
*                        gph box `y1' `x1' `y2' `x2' 4

                        replace `e1'=invnorm(uniform())
                        replace `e2'=rho*`e1'+sqrt(1.0-rho*rho)*invnorm(uniform())

                        replace `e1' = nc + np*((`e1' + 3)/6)
                        replace `e2' = nr - np*((`e2' + 3)/6)
                        gph vpoint `e2' `e1' , size(10) symbol(`sym')

                        local mrho: display %4.2f rho
                        local my=int(nr-np)-300
                        local mx=int(nc + (np/2))
                        gph text `my' `mx' 0 0 rho = `mrho' 

                        scalar j = j + 1
                        scalar nc = nc + nix

                        scalar ii=ii+1

                }

        scalar i = i + 1
        scalar nr = nr + niy

}

        gph close

        restore

end

exit
