program define tests
    version 4.0

    preserve 
    clear    

    quietly {
        set obs 101
        gen x=.
        gen y=.
        gen x1=.
        gen y1=.
        gen zer=0
    }

    global C1_1 "Case 1: Mean of normal, sigma^2 known: Give n, sigma^2, xbar."
    global C1_2 "Case 2: Mean of normal, sigma^2 unknown: Give n, s^2, xbar."
    global C1_3 "Case 3: Mean of nonnormal, sigma^2 unknown but n large: Give n, s^2, xbar."
    global C1_4 "Case 4: Variance of normal: Give n, s^2."
    global C1_5 "Case 5: 0-1 proportion pi (exact): Give n and p."
    global C1_6 "Case 6: 0-1 proportion pi (approximate): Give n and p."
    global C1_7 "Case 7: Ratio of normal variances: Give n1, n2, s1^2, s2^2."
    global C1_8 "Case 8: Difference of normal means, independent samples, variances equal: Give n1, n2, s1^2, s2^2, xbar1, xbar2."
    global C1_9 "Case 9: Difference of normal means, independent samples, variances unequal: Give n1, n2, s1^2, s2^2, xbar1, xbar2."
    global C1_10 "Case 10: Mean of difference in paired data: Give n (# of pairs), s^2 for differences in pairs, xbar=mean of pair differences."
    global C1_11 "Case 11: Difference of proportions pi1-pi2: Give n1, n2, p1, p2."


    window control static C1_1  5   5  260  8
    window control static C1_2  5  13  260  8
    window control static C1_3  5  21  260  8
    window control static C1_4  5  29  260  8
    window control static C1_5  5  37  260  8
    window control static C1_6  5  45  260  8
    window control static C1_7  5  53  260  8
    window control static C1_8  5  61  260 16
    window control static C1_9  5  77  260 16
    window control static C1_10 5  93  260 16
    window control static C1_11 5 109  260  8



    global D1_1  "Test for Mean of normal, sigma known:"
    global D1_2  "Test for Mean of normal, sigma unknown:"
    global D1_3  "Test for Mean of nonnormal, sigma unknown but n large:"
    global D1_4  "Test for Variance of normal:"
    global D1_5  "Test for 0-1 proportion pi (exact):"
    global D1_6  "Test for 0-1 proportion pi (approximate):"
    global D1_7  "Test for Ratio of normal variances:"
    global D1_8  "Test for Difference of normal means, ind samples, vars equal:"
    global D1_9  "Test for Difference of normal means, ind samples, vars unequal:"
    global D1_10 "Test for Mean of difference in paired data:"
    global D1_11 "Test for Difference of proportions pi1-pi2:"

    global C_1 "Case"
    global C_3 "1 2 3 4 5 6 7 8 9 10 11"
    window control static C_1          270  5 20 10
    global C_2 "1"
    window control ssimple C_3     270 15 20 110 C_2

    global D_alpha "alpha"
    window control static D_alpha 5 125 18 8
    global alpha=.05
    window control edit 25 125 18 8 alpha

    global D_n "n"
    window control static D_n 45 125 18 8
    global n=10
    window control edit  65 125 18 8 n

    global D_xbar "xbar"
    window control static D_xbar 85 125 18 8
    global xbar=11
    window control edit 105 125 18 8 xbar

    global D_sigma2 "sig^2"
    window control static D_sigma2 125 125 18 8
    global sigma2=4
    window control edit   145 125 18 8 sigma2

    global D_s2 "s^2"
    window control static D_s2 165 125 18 8
    global s2=0
    window control edit   185 125 18 8 s2

    global D_p "p"
    window control static D_p 205 125 18 8
    global p=0
    window control edit  225 125 18 8 p

    global D_n1 "n1"
    window control static D_n1 5 135 18 8
    global n1=0
    window control edit  25 135 18 8 n1

    global D_n2 "n2"
    window control static D_n2 45 135 18 8
    global n2=0
    window control edit  65 135 18 8 n2

    global D_xbar1 "xbar1"
    window control static D_xbar1 85 135 18 8
    global xbar1=0
    window control edit  105 135 18 8 xbar1

    global D_xbar2 "xbar2"
    window control static D_xbar2 125 135 18 8
    global xbar2=0
    window control edit   145 135 18 8 xbar2

    global D_s12 "s1^2"
    window control static D_s12 165 135 18 8
    global s12=0
    window control edit  185 135 18 8 s12

    global D_s22 "s2^2"
    window control static D_s22 205 135 18 8
    global s22=0
    window control edit  225 135 18 8 s22

    global D_p1 "p1"
    window control static D_p1 5 145 18 8
    global p1=0
    window control edit  25 145 18 8 p1

    global D_p2 "p2"
    window control static D_p2 45 145 18 8
    global p2=0
    window control edit  65 145 18 8 p2

    global D_delta "hyp value"
    window control static D_delta 110 160 32 8
    global delta=10
    window control edit 145 160 18 8 delta

    global D_test1 "Test"
    global D_test2 "Right-Sided Left-Sided Two-Sided"
    window control static D_test1           165 145 18 8 
    global D_test3 "Right-Sided"
    window control ssimple  D_test2   185 145 50 40 D_test3


    window control button "Run"       5 160 30 14 D_b1
    window control button "Close"    40 160 30 14 D_b2
    window control button "Help"     75 160 30 14 D_b3 help

    global D_b1 "testdr"
    global D_b2 "exit 3000"
    global D_b3 "whelp tests"

    cap noi window dialog "Tests of Hypotheses" $D_dlgx $D_dlgy 300 200

    restore

end

program define testdr
    version 4.0


*  Check alpha:

    if $alpha<=0 | $alpha >=1 {
        sstopbox stop "alpha must be in (0,1)"
        exit}        

*  Check input values:

    local case=$C_2

    ckin `case'
    if $ret==1 {exit}

*  Define tcase (sidedness of test):

    if "$D_test3"=="Right-Sided" {local tcase=1}
    if "$D_test3"=="Left-Sided"  {local tcase=2}
    if "$D_test3"=="Two-Sided"   {local tcase=3}

*  Define dcase (Z, t, chi-square, or F):

    if `case'==1 | `case'==6 | `case'==11 {local dcase=1}
    if `case'==2 | `case'==3 | `case'==8 | `case'==9 | `case'==10 {local dcase=2}
    if `case'==4 {local dcase=3}
    if `case'==7 {local dcase=4}

*  Display type of test, alpha, and hypothesized value in results window:

    di " "
    di "$D_test3 " "${D1_`case'}"

    di "alpha = " $alpha
    di "Hypothesized value = " $delta
    di " "



*  Now do the appropriate case, including:

*    1. Display input in results window
*    2. Calculate test statistic and if necessary degrees of freedom

*-----------------------------------------------------------
    if `case'==1 {
*-----------------------------------------------------------


        di "n = " $n ", sigma^2 = " $sigma2 ", xbar = " $xbar 
        local ts=($xbar-$delta)/sqrt($sigma2/$n)}

*-----------------------------------------------------------
    if `case'==2 | `case'==3 {
*-----------------------------------------------------------


        di "n = " $n ", s^2 = " $s2 ", xbar = " $xbar 
        local df1=$n-1

        local ts=($xbar-$delta)/sqrt($s2/$n)}

*-----------------------------------------------------------
    if `case'==4 {
*-----------------------------------------------------------

        di "n = " $n ", s^2 = " $s2
        local df1=$n-1
        local ts=(($n-1)*$s2)/$delta}

*-----------------------------------------------------------
    if `case'==5 {
*-----------------------------------------------------------

        exit}
        
*-----------------------------------------------------------
    if `case'==6 {
*-----------------------------------------------------------

        di "n = " $n ", p = " $p

        local ts=($p-$delta)/sqrt($delta*(1-$delta)/$n)}

*-----------------------------------------------------------
    if `case'==7 {
*-----------------------------------------------------------

        di "n1 = " $n1 ", n2 = " $n2 ", s1^2 = " $s12 ", s2^2 = " $s22

        local df1=$n1-1
        local df2=$n2-1
        local ts=($s12/$s22)/$delta}

*-----------------------------------------------------------
    if `case'==8 {
*-----------------------------------------------------------

        local s2p=(($n1-1)*$s12+($n2-1)*$s22)/($n1+$n2-2)
        local df1=$n1+$n2-2

        di "n1 = " $n1 ", n2 = " $n2 ", xbar1 = " $xbar1 ", xbar2 = " $xbar2 
        di "s1^2 = " $s12 ", s2^2 = " $s22 ", sp^2 = " `s2p' ", df = " `df1'

        local ts=(($xbar1-$xbar2)-$delta)/sqrt(`s2p'*((1/$n1)+(1/$n2)))}

*-----------------------------------------------------------
    if `case'==9 {
*-----------------------------------------------------------


        local dfn=(($s12/$n1)+($s22/$n2))^2
        local dfd=(($s12/$n1)^2/($n1-1))+(($s22/$n2)^2/($n2-1))
        local df1=int((`dfn'/`dfd')+.5)

        di "n1 = " $n1 ", n2 = " $n2 ", xbar1 = " $xbar1 ", xbar2 = " $xbar2 
        di "s1^2 = " $s12 ", s2^2 = " $s22 ", df = " `df1'

        local s2p=(($n1-1)*$s12+($n2-1)*$s22)/($n1+$n2-2)
        local ts=(($xbar1-$xbar2)-$delta)/sqrt(($s12/$n1)+($s22/$n2))}

*-----------------------------------------------------------
    if `case'==10 {
*-----------------------------------------------------------

        di "n = " $n ", sd^2 = " $s2 ", dbar = " $xbar 

        local df1 = $n-1
        local ts  = ($xbar-$delta)/sqrt($s2/$n)}

*-----------------------------------------------------------
    if `case'==11 {
*-----------------------------------------------------------

        di "n1 = " $n1 ", n2 = " $n2 ", p1 = " $p1 ", p2 = " $p2

        local poolp = ($n1*$p1+$n2*$p2)/($n1+$n2)
        local ts = ($p1-$p2)/sqrt(`poolp'*(1-`poolp')*((1/$n1)+(1/$n2)))}

*  Display calculated value of test statistic in results window:

    if `dcase'==1 {di "Z_calc = " `ts'}
    if `dcase'==2 {di "t_calc = " `ts'}
    if `dcase'==3 {di "chisquare_calc= " `ts'}
    if `dcase'==4 {di "F_calc = " `ts'}

    global D_crit1 "Critical value: "
    global D_crit2 "Critical values: "

*-------------------------------------
*  Get critical values and pvalues:
*-------------------------------------

    if `dcase'==1 {

        if `tcase'==1 {
                        local critr = invnorm(1-$alpha)
                        local pval=1-normprob(`ts')
        }
        
        if `tcase'==2 {
                        local critl = invnorm($alpha)
                        local pval=normprob(`ts')
        }

        if `tcase'==3 {
                        local critr = invnorm(1-$alpha/2)
                        local critl = invnorm($alpha/2)
                        local c2=abs(`ts')
                        local c1=-`c2'
                        local pval=2*(1-normprob(abs(`ts')))
        }
    }

    if `dcase'==2 {

        if `tcase'==1 {
                        local critr = invt(`df1',1-2*$alpha)
                        if `ts' < 0 {local pval=1-tprob(`df1',`ts')/2}
                        if `ts' >=0 {local pval=tprob(`df1',`ts')/2}
        }

        if `tcase'==2 {
                        local critl = -invt(`df1',1-2*$alpha)
                        if `ts' < 0 {local pval=tprob(`df1',`ts')/2}
                        if `ts' >=0 {local pval=1-tprob(`df1',`ts')/2}
        }

        if `tcase'==3 {
                        local critr = invt(`df1',1-$alpha)
                        local critl = -`critr'
                        local c2=abs(`ts')
                        local c1=-`c2'
                        local pval=tprob(`df1',`ts')
        }

    }

    if `dcase'==3 {

        if `tcase'==1 {
                        local critr = invnchi(`df1',0,1-$alpha)
                        local pval=chiprob(`df1',`ts')
        }

        if `tcase'==2 {
                        local critl = invnchi(`df1',0,$alpha)
                        local pval=1-chiprob(`df1',`ts')
        }

        if `tcase'==3 {
                        local critr = invnchi(`df1',0,1-$alpha/2)
                        local critl = invnchi(`df1',0,$alpha/2)
                        local pv=1-chiprob(`df1',`ts')
                        if `pv' < .5 {
                            local c1=`ts'
                            local c2=invnchi(`df1',0,1-`pv')
                            local pval=2*`pv'}
                        else {
                            local c1=invnchi(`df1',0,1-`pv')
                            local c2=`ts'
                            local pval=2*(1-`pv')}
        }
    }

    if `dcase'==4 {

        if `tcase'==1 {
                        local critr = invfprob(`df1',`df2',$alpha)
                        local pval=fprob(`df1',`df2',`ts')
        }

        if `tcase'==2 {
                        local critl = invfprob(`df1',`df2',1-$alpha)
                        local pval=1-fprob(`df1',`df2',`ts')
        }

        if `tcase'==3 {
                        local critr = invfprob(`df1',`df2',$alpha/2)
                        local critl = invfprob(`df1',`df2',1-$alpha/2)
                        local pv=1-fprob(`df1',`df2',`ts')
                        if `pv' < .5 {
                            local c1=`ts'
                            local c2=invfprob(`df1',`df2',`pv')
                            local pval=2*`pv'}
                        else {
                            local c1=invfprob(`df1',`df2',`pv')
                            local c2=`ts'
                            local pval=2*(1-`pv')
                        }
        }
    }

*---------------------------------------------------------
*  Put critical values and decision in results window:
*---------------------------------------------------------

    if `tcase'==1 {
                    di "$D_crit1" `critr'
                    if `ts' > `critr' { di "Reject H_0"}
                    else              { di "Fail to reject H_0"}
    }
    
    if `tcase'==2 {
                    di "$D_crit1" `critl'    
                    if `ts' < `critl' { di "Reject H_0"}
                    else              { di "Fail to reject H_0"}
    }

    if `tcase'==3 {
                    di "$D_crit2" `critl' " , " `critr' 
                    if `ts' < `critl' | `ts' > `critr' { di "Reject H_0"}
                    else                               { di "Fail to reject H_0"}
    }

*  Display p-value in results window:

    di "p-value = " `pval'

    di " "

*------------------------------------------------------
*  Now do graph:
*------------------------------------------------------

    gph open
    gph pen 1

*-------------------------
*  Get x and y:
*-------------------------
    
    local umin=.0001

    if `dcase'==1 {
        local xmin=invnorm(`umin')
        local xmax=invnorm(1-`umin')
        replace x=`xmin' + (`xmax'-`xmin')*(_n-1)/(_N-1)
        pdf_Z x y
    }

    if `dcase'==2 {
        local xmin=-invt(`df1',1-2*`umin')
        local xmax=-`xmin'
        replace x=`xmin' + (`xmax'-`xmin')*(_n-1)/(_N-1)
        pdf_t x y `df1'
    }

    if `dcase'==3 {
        local xmin=invnchi(`df1',0,`umin')
        local xmax=invnchi(`df1',0,1-`umin')
        replace x=`xmin' + (`xmax'-`xmin')*(_n-1)/(_N-1)
        pdf_chi2 x y `df1'
    }
    
    if `dcase'==4 {
        local xmin=0.
        local xmax=invfprob(`df1',`df2',`umin')
        replace x=`xmin' + (`xmax'-`xmin')*(_n-1)/(_N-1)
        pdf_f x y `df1' `df2'
    }

*-----------------------
*  Draw graph:
*-----------------------


    graph y x, c(l) s(.) xlab ylab  pen(3)  bbox(4000,1000,23000,29000,850,400,0) l1(" ") l2(" ") b1(" ") b2(" ")
    gphconv

*-----------------------
*  Do shading:
*-----------------------

    gph pen 2

    local mpv: display %4.3f `pval'
    local mstat: display %5.3f `ts'

    replace x1=.
    replace y1=.

    if `tcase'==1 {
        replace y1=y if x > `ts'
        replace x1=x if x > `ts'}

    if `tcase'==2 {
        replace y1=y if x < `ts'
        replace x1=x if x < `ts'}

    if `tcase'==3 {
        replace y1=y if x < `c1' | x > `c2'
        replace x1=x if x < `c1' | x > `c2'}

    segments x1 zer x1 y1

*-----------------------------------------------------
*  Do observed and equivalent values and their arrows:
*-----------------------------------------------------

    summarize y
    local ymax1=-(_result(6)/5)
    local ymax2=-(_result(6)/7)
    local ymax4=(_result(6)/2)

    local hsize=400

    global stcase="Z_calc"
    if `dcase'==2 {global stcase="t_calc"}
    if `dcase'==3 {global stcase="chisq_calc"}
    if `dcase'==4 {global stcase="F_calc"}

    if `tcase' == 3 {
        local mc1:display %5.3f `c1'
        local mc2:display %5.3f `c2'

        local xx1=max(`c1',`xmin')
        local xx2=min(`c2',`xmax')

        if `c1' >= `xmin' & `c2' <= `xmax' {
            drline `xx1' 0 `xx1' `ymax2'
            drline `xx2' 0 `xx2' `ymax2'
            drhead `xx1' 0 `hsize' 1
            drhead `xx2' 0 `hsize' 1
        }

        local just1=1
        local just2=-1
        if `ts' < `xmin' | `ts' > `xmax' {
            local just1=-1
            local just2=1}
        if abs(`ts'-`c1') < .001 {
            drtext `xx1' `ymax1' `just1' "$stcase = `mc1'"
            drtext `xx2' `ymax1' `just2' "`mc2' = equiv val"}
        if abs(`ts'-`c1') >= .001 {
            drtext `xx1' `ymax1' `just1' "equiv val = `mc1'"
            drtext `xx2' `ymax1' `just2' "`mc2' = $stcase"}
    }

    else {

        if `ts' >= `xmin' & `ts' <= `xmax' {
            drline `ts' 0 `ts' `ymax1'
            drhead `ts' 0 `hsize' 1
            if `tcase'==1 {drtext `ts' `ymax1' -1 "`mstat' = $stcase"}
            if `tcase'==2 {drtext `ts' `ymax1' 1 "$stcase = `mstat'"}
        }

        else {
            if `ts' >  `xmax' {drtext `xmax' `ymax1' 1 "`mstat' = $stcase"}
            if `ts' <= `xmin' {drtext `xmin' `ymax1' -1 "`mstat' = $stcase"}
        }
    }

*--------------------------------------------
*  Now do critical value(s) and their arrow(s):
*--------------------------------------------

    gph pen 3
    lines x y
    drline `xmin' 0 `xmax' 0

    if `dcase'==1 {gph text 6000 20000 0 -1 Z Curve}
    if `dcase'==2 {gph text 6000 20000 0 -1 t Curve with df = `df1'}
    if `dcase'==3 {gph text 6000 16000 0 -1 chi-square Curve with df = `df1'}
    if `dcase'==4 {gph text 6000 16000 0 -1 F Curve with df = `df1',`df2'}


    global D_1="Z_"
    global D_2="t_"
    global D_3="chi^2_"
    global D_4="F_"

    local alph = $alpha
    if `tcase'==3 {local alph=$alpha/2}

    local alphr:display %5.4f `alph'
    local alphl:display %5.4f 1-`alph'

    global DR= "${D_`dcase'}`alphr'"
    global DL= "${D_`dcase'}`alphl'"

    if `tcase'==1 | `tcase'==3 {
                                drline `critr' 0 `critr' `ymax4'
                                drhead `critr' 0 `hsize' 2}
    if `tcase'==2 | `tcase'==3 {
                                drline `critl' 0 `critl' `ymax4'
                                drhead `critl' 0 `hsize' 2}
    if `tcase'==3 {
        local mc3:display %5.3f `critl'
        local mc4:display %5.3f `critr'
        drhead `critr' 0 `hsize' 2
        drhead `critl' 0 `hsize' 2
        drtext `critl' `ymax4' 1 "$DL = `mc3'"
        drtext `critr' `ymax4' -1 "`mc4' = $DR"}    

    if `tcase'==1 {
        local mc3:display %5.3f `critr'
        drtext `critr' `ymax4' -1 "`mc3' = $DR"}

    if `tcase'==2 {
        local mc3:display %5.3f `critl'
        drtext `critl' `ymax4' 1 "$DL = `mc3'"}

    gph pen 2
    gph text 3000 16000 0 0 p-value = shaded area = `mpv' 

*----------------------------------------
*  Finally, put sample statistics on top:
*-----------------------------------------

    gph text 1000 16000 0 0 $D_test3 ${D1_`case'}

    addinf

    gph close
            
end

program define addinf
*----------------------------------------------------
*
*   Put 2nd line of information to graph in tests.ado
*
*-----------------------------------------------------
    version 4.0


    local case=$C_2

    if `case'==1 {
        gph text 2000 16000 0 0 n =  $n xbar = $xbar sig^2 = $sigma2 alpha = $alpha hyp val = $delta}

    if `case'==2 | `case'==3 {
        gph text 2000 16000 0 0 n =  $n xbar = $xbar s^2 = $s2 alpha = $alpha hyp val = $delta}

    if `case'==4 {
        gph text 2000 16000 0 0 n =  $n s^2 = $s2 alpha = $alpha hyp val = $delta}

    if `case'==6 {
        gph text 2000 16000 0 0 n =  $n p = $p alpha = $alpha hyp val = $delta}

    if `case'==7 {
        gph text 2000 16000 0 0 n1 =  $n1 n2 = $n2 s1^2 = $s12 s2^2 = $s22 alpha = $alpha hyp val = $delta}

    if `case'==8 | `case'==9 {
        gph text 2000 16000 0 0 n's: $n1,$n2 xbars: $xbar1,$xbar2 var's: $s12,$s22 alpha = $alpha hyp val = $delta}

    if `case'==10 {
        gph text 2000 16000 0 0 n =  $n dbar = $xbar sd^2 = $s2 alpha = $alpha hyp val = $delta}

    if `case'==11 {
        gph text 2000 16000 0 0 n1 =  $n1 n2 = $n2 p1 = $p1 p2 = $p2 alpha = $alpha hyp val = $delta}
end

program define ckin
    version 4.0

    local case=`1'

    global ret=1

    if `case'==1 {

        if $n < 1 {
            sstopbox stop "n must be at least 1"
            exit}
        if $sigma2 <= 0 {
            sstopbox stop "sigma^2 must be positive"
            exit}
        if $xbar==0 {
            sstopbox stop "you must give xbar"
            exit}

    }

    if `case'==2 | `case'==3 {

        if $n < 2 {
            sstopbox stop "n must be at least 2"
            exit}
        if $s2 <= 0 {
            sstopbox stop "s^2 must be positive"
            exit}
        if $xbar==0 {
            sstopbox stop "you must give xbar"
            exit}

    }

*-----------------------------------------------------------
    if `case'==4 {
*-----------------------------------------------------------

        if $n < 2 {
            sstopbox stop "n must be at least 2"
            exit}
        if $s2 <= 0 {
            sstopbox stop "s^2 must be positive"
            exit}
        if $delta <= 0 {
            sstopbox stop "hypothesized value must be positive"
            exit}

    }

*-----------------------------------------------------------
    if `case'==5 {
*-----------------------------------------------------------

        sstopbox stop "This case has not been implemented"
        exit}
        
*-----------------------------------------------------------
    if `case'==6 {
*-----------------------------------------------------------

        if $n < 1 {
            sstopbox stop "n must be at least 1"
            exit}
        if $p<=0 | $p>=1 {
            sstopbox stop "p must be between 0 and 1"
            exit}
        if $delta<=0 | $delta>=1 {
            sstopbox stop "hypothesized value must be between 0 and 1"
            exit}

    }

*-----------------------------------------------------------
    if `case'==7 {
*-----------------------------------------------------------

        if $n1 < 1 | $n2 < 1 {
            sstopbox stop "n1 and n2 must be at least 1"
            exit}
        if $s12<=0 | $s22<=0 {
            sstopbox stop "s1^2 and s2^2 must be positive"
            exit}
        if $delta<=0 {
            sstopbox stop "hypothesized value must be positive"
            exit}

    }

*-----------------------------------------------------------
    if `case'==8 {
*-----------------------------------------------------------

        if $n1 < 1 | $n2 < 1 {
            sstopbox stop "n1 and n2 must be at least 1"
            exit}
        if $xbar1==0 | $xbar2==0 {
            sstopbox stop "you must specify xbar1 and xbar2"
            exit}
        if $s12<=0 | $s22<=0 {
            sstopbox stop "s1^2 and s2^2 must be positive"
            exit}

    }

*-----------------------------------------------------------
    if `case'==9 {
*-----------------------------------------------------------

        if $n1 < 1 | $n2 < 1 {
            sstopbox stop "n1 and n2 must be at least 1"
            exit}
        if $xbar1==0 | $xbar2==0 {
            sstopbox stop "you must specify xbar1 and xbar2"
            exit}
        if $s12<=0 | $s22<=0 {
            sstopbox stop "s1^2 and s2^2 must be positive"
            exit}

    }

*-----------------------------------------------------------
    if `case'==10 {
*-----------------------------------------------------------

        if $n < 1 {
            sstopbox stop "n must be at least 1"
            exit}
        if $s2 <= 0 {
            sstopbox stop "s^2 must be positive"
            exit}
        if $xbar==0 {
            sstopbox stop "you must give xbar"
            exit}

    }

*-----------------------------------------------------------
    if `case'==11 {
*-----------------------------------------------------------

        if $n1 < 1 | $n2 < 1{
            sstopbox stop "n1 and n2  must be at least 1"
            exit}
        if $p1 <= 0 | $p1 >= 1 | $p2 <= 0 | $p2 >= 1 {
            sstopbox stop "p1 and p2 must both be between 0 and 1"
            exit}
        if $delta!=0 {
            sstopbox stop "hypothesized value must be zero"
            exit}

    }

    global ret=0
end

exit
